






#import "Farsi.h"
#import "WeekSampleExtendingBasicFormat.h"

@interface Farsi() {
    NSMutableSet *_minShowSlowRopeGreen;
}

@end

@implementation Farsi



+ (instancetype)issuerAndInstance {
    static id issuerAndInstance = nil;

    static dispatch_once_t toolToken;
    dispatch_once(&toolToken, ^{
        issuerAndInstance = [[self alloc] init];
    });

    return issuerAndInstance;
}


- (NSMutableSet *)minShowSlowRopeGreen {
    if (!_minShowSlowRopeGreen) {
        _minShowSlowRopeGreen = [[NSMutableSet alloc] init];
    }
    return _minShowSlowRopeGreen;
}




+ (BOOL)achievedStrengthEsperantoHourlyLiteral:(WeekSampleExtendingBasicFormat *)zb_destination {
    return [self.issuerAndInstance achievedStrengthEsperantoHourlyLiteral:zb_destination];
}

- (BOOL)achievedStrengthEsperantoHourlyLiteral:(WeekSampleExtendingBasicFormat *)zb_destination {
    if ([self.minShowSlowRopeGreen containsObject:zb_destination]) {
        return NO;
    }
    [self.minShowSlowRopeGreen addObject:zb_destination];
    return YES;
}


+ (BOOL)screenMeasuredBehaveSubtitlesFrequencyArcade:(WeekSampleExtendingBasicFormat *)zb_destination {
    return [self.issuerAndInstance screenMeasuredBehaveSubtitlesFrequencyArcade:zb_destination];
}

- (BOOL)screenMeasuredBehaveSubtitlesFrequencyArcade:(WeekSampleExtendingBasicFormat *)zb_destination {
    if (![self.minShowSlowRopeGreen containsObject:zb_destination]) {
        return NO;
    }
    [self.minShowSlowRopeGreen removeObject:zb_destination];
    return YES;
}


+ (void)decrementSiteWeeklyRepairFalloffDestroy {
    [self.issuerAndInstance decrementSiteWeeklyRepairFalloffDestroy];
}

- (void)decrementSiteWeeklyRepairFalloffDestroy {
    [self.minShowSlowRopeGreen removeAllObjects];
}


+ (NSInteger)companyReferentSelectedHighlightPromptKnow {
    return [self.issuerAndInstance companyReferentSelectedHighlightPromptKnow];
}

- (NSUInteger)companyReferentSelectedHighlightPromptKnow {
    return self.minShowSlowRopeGreen.count;
}


+ (NSString *)mindGuestName {
    if (NSThread.isMainThread) {
        return @"";
    }else {
        NSString *label = [NSString stringWithCString:dispatch_queue_get_label(DISPATCH_CURRENT_QUEUE_LABEL) encoding:NSUTF8StringEncoding];
        return label ?: NSThread.currentThread.name;
    }
}


+ (void)winCenter:(PlainLevel)zb_level
          visitor:(const char *)visitor
      boldDayOver:(const char *)boldDayOver
          nominal:(NSUInteger)nominal
       jobDesired:(id)jobDesired
        taskMolar:(NSString *)taskMolar, ... {
    va_list args;
    
    if (taskMolar) {
        va_start(args, taskMolar);
        
        NSString *icyFitNone = [[NSString alloc] initWithFormat:taskMolar arguments:args];
        
        va_end(args);
        
        va_start(args, taskMolar);
        
        [self.issuerAndInstance rootSpectralLabelLaunchedEnds:zb_level
                                   icyFitNone:icyFitNone
                                    indigoShe:[self mindGuestName]
                                      visitor:[NSString stringWithFormat:@"%s", visitor]
                                  boldDayOver:[NSString stringWithFormat:@"%s", boldDayOver]
                                      nominal:nominal
                                   jobDesired:jobDesired];
        
        va_end(args);
    }
}


- (void)rootSpectralLabelLaunchedEnds:(PlainLevel)zb_level
              icyFitNone:(NSString *)icyFitNone
               indigoShe:(NSString *)indigoShe
                 visitor:(NSString *)visitor
             boldDayOver:(NSString *)boldDayOver
                 nominal:(NSUInteger)nominal
              jobDesired:(id)jobDesired {
    
    for (WeekSampleExtendingBasicFormat *funGasp in self.minShowSlowRopeGreen) {
        
        NSString *sawSobExactMessage;
        
        if (!funGasp.clampShe) continue;
        
        sawSobExactMessage = sawSobExactMessage == nil ? icyFitNone : sawSobExactMessage;
        
        if ([funGasp armQuietFarsiHectaresGivenEar:zb_level kernels:visitor boldDayOver:boldDayOver icyFitNone:icyFitNone]) {
            
            NSString *fullyType = sawSobExactMessage == nil ? icyFitNone :sawSobExactMessage;
            
            NSString *list = [self expandOverride:boldDayOver];
            
            if (funGasp.intervalsResolvingSensitiveStickyFunk) {
                dispatch_async(funGasp.clampShe, ^{
                    [funGasp formAge:zb_level behave:fullyType indigoShe:indigoShe visitor:visitor boldDayOver:list nominal:nominal
                          jobDesired:jobDesired];
                });
            }else {
                dispatch_sync(funGasp.clampShe, ^{
                    [funGasp formAge:zb_level behave:fullyType indigoShe:indigoShe visitor:visitor boldDayOver:list nominal:nominal
                          jobDesired:jobDesired];
                });
            }
        }
    }
}

- (NSString *)expandOverride:(NSString *)boldDayOver {
    NSString *list = boldDayOver;
    NSRange wayApple = [list rangeOfString:@"("];
    
    if (wayApple.location != NSNotFound) {
        list = [list substringToIndex:wayApple.location];
    }
    list = [list stringByAppendingString:@"()"];
    return list;
}

@end
